#!/bin/bash

# Script to generate a folder poem from a text file source
# and then change the timedate stamps on each folder

# 197701030547:In January,
# 197701030550:_the heater on too high,
# 197701030555:_dry throat of early morning,
# 197701030558:_tangles of lover,
# 197701030559:__comfortable, too close,
# 197701030600:_in this stretched space
# 197701030601:her pregnancy began.

workingdir="`pwd`"
filename="lines-dates.txt"
textold=""
depthold=0
depthchange=0
text=""

# create each folder name in the correct file heirarchy

open ${workingdir}

osascript<<END
tell application "Finder"
	set current view of front window to list view
	set toolbar visible of front window to false
	set zoomed of front window to true
	set visible of column label column of list view options of front window to true
	set visible of column modification date column of list view options of front window to true
	set sort direction of sort column of list view options of front window to normal
	set sort column of list view options of front window to modification date column
	try
		tell application "Finder" to update items of front window
	end try
end tell
tell application "System Events"
	keystroke "a" using {command down}
	key code 124 using {command down, option down}
end tell
END

while read line; do
	# parse line into time, seconds delay, and text for folder name
    date=`echo ${line} | cut -d : -f 1`
	seconds=`echo ${line} | cut -d : -f 2`
    text=`echo ${line} | cut -d : -f 3`

	# wait some number of seconds
	sleep ${seconds}

	# if depth increased, navigate into last directory
	depth=`echo ${line} | od -c | grep -o "_" | wc -l`		
	if [ ${depth} -gt ${depthold} ]
		then
		cd "${textold}"
	fi	
	# if depth decreased, navigate out n directories up
	if [ ${depth} -lt ${depthold} ]
		then
		depthchange=${depthold}-${depth}
		for (( c=1; c<=${depthchange}; c++ ))
		do
			cd ..
		done
	fi

	# create folder with text name sans _, touch with date
    text=`echo ${text} | sed 's/_//g'`
	mkdir "${text}"

	# touch -t $date "${text}"

	textold=${text}
	depthold=${depth}

	osascript<<END
	tell application "System Events"
		keystroke "a" using {command down}
		key code 124 using {command down, option down}
		keystroke "a" using {command down, option down}
	end tell
END

done < "${filename}"

# return to root level
cd "${workingdir}"

while read line; do
	# parse line into time, seconds delay, and text for folder name
    date=`echo ${line} | cut -d : -f 1`
	seconds=`echo ${line} | cut -d : -f 2`
    text=`echo ${line} | cut -d : -f 3  | sed 's/_//g'`

	# wait some number of seconds
	sleep ${seconds}

	# find filename in heirarchy, and touch with date
	linepath=`find . -type d -name "${text}" | head -n 1`
	touch -t $date "${linepath}"

done < "${filename}"
